## umps3 3.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(umps
        VERSION 3.0.0)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_compile_options(-D_FORTIFY_SOURCE=2 -O2 -Wall -pedantic)

include(GNUInstallDirs)

include(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
configure_file(config.h.in config.h)

# Check for MIPS cross toolchain
set(XT_PREFIXES ${MIPS_TOOL_PREFIX})
if(NOT XT_PREFIXES)
        set(XT_PREFIXES mips-sde-elf-)
        if(WORDS_BIGENDIAN)
                set(XT_PREFIXES mips-linux-gnu- mips-linux-
                        mips-elf- ${XT_PREFIXES})
        else()
                set(XT_PREFIXES mipsel-linux-gnu- mipsel-linux-
                        mipsel-elf- ${XT_PREFIXES})
        endif()
endif()

foreach(PREF ${XT_PREFIXES})
        find_program(XCGCC ${PREF}gcc)
        if(XCGCC)
                set(XT_PREFIX ${PREF})
                break()
        endif()
endforeach()

if(NOT XCGCC)
        message(FATAL_ERROR "MIPS toolchain (gcc) not found.")
endif()

find_program(XCAS ${PREF}as)
if(NOT XCAS)
        message(FATAL_ERROR "MIPS toolchain (as) not found.")
endif()

find_program(XCLD ${PREF}ld)
if(NOT XCLD)
        message(FATAL_ERROR "MIPS toolchain (ld) not found.")
endif()

# Checks for libelf
find_library(LIBELF elf)
if(NOT LIBELF)
        message(FATAL_ERROR "libelf not found.")
endif()

# Checks for libdl
find_library(LIBDL dl)
if(NOT LIBDL)
        message(FATAL_ERROR "libdl not found.")
endif()

include(FindPkgConfig)
pkg_check_modules(SIGCPP REQUIRED sigc++-2.0)

find_package(Boost 1.34 REQUIRED)

find_package(Qt5 COMPONENTS Widgets REQUIRED)

if(${Qt5_VERSION_MINOR} LESS 11)
        execute_process(COMMAND git apply ${CMAKE_SOURCE_DIR}/patch/Qt5.patch
                        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

add_subdirectory(src)
add_subdirectory(man)

add_custom_target(uninstall ${CMAKE_COMMAND} -P
        "${PROJECT_SOURCE_DIR}/Uninstall.cmake")

=== man/CMakeLists.txt ===
set(RONN_ORGANIZATION "VirtualSquare")
set(RONN_ARGS --organization=${RONN_ORGANIZATION})

### ronn pages
file(GLOB UMPS_RONN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8].ronn)
set(UMPS_MAN_FILES)
foreach(UMPS_RONN_PATH IN LISTS UMPS_RONN_PAGES)
# UMPS_RONNPAGE: basename of UMPS_RONN_PATH
	get_filename_component(UMPS_RONNPAGE ${UMPS_RONN_PATH} NAME)
# UMPS_MANPAGE: UMPS_RONNPAGE without the suffix
	string(REGEX REPLACE "\.ronn$" "" UMPS_MANPAGE ${UMPS_RONNPAGE})
	list(APPEND UMPS_MAN_FILES ${UMPS_MANPAGE})
endforeach(UMPS_RONN_PATH)

add_custom_target(${PROJECT_NAME}${PROJECT_VERSION_MAJOR}_manpages ALL make RONN_ARGS="${RONN_ARGS}" ${UMPS_MAN_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

### man pages
file(GLOB UMPS_MAN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8])
foreach(UMPS_MAN_PATH IN LISTS UMPS_MAN_PAGES)
	get_filename_component(UMPS_MANPAGE ${UMPS_MAN_PATH} NAME)
	string(REGEX REPLACE ".*\\." "" MAN_CHAPTER ${UMPS_MANPAGE})
	install(FILES ${UMPS_MAN_PATH} DESTINATION ${CMAKE_INSTALL_MANDIR}/man${MAN_CHAPTER})
endforeach(UMPS_MAN_PATH)

=== man/Makefile ===
RONN=ronn
RONNOK := $(shell command -v ${RONN} 2> /dev/null)

none:

% : %.ronn
ifdef RONNOK
# copy copyright notice
	grep "^\.\\\\\"" $< > $@ || true
# run ronn
	$(RONN) -r ${RONN_ARGS} --pipe $< >> $@
# delete useless trailing "" in .TH
	sed -i '/^\.TH /s/ ""$$//' $@
else
	echo "${RONN} is not available. Manpage $@ cannot be updated" >/dev/stderr >&2
endif

=== src/CMakeLists.txt ===
set(UMPS_DATA_DIR ${CMAKE_INSTALL_FULL_DATADIR}/umps3)

add_subdirectory(base)
add_subdirectory(frontends)
add_subdirectory(include)
add_subdirectory(support)
add_subdirectory(tests)
add_subdirectory(umps)

=== src/frontends/CMakeLists.txt ===
add_subdirectory(qmps)

=== src/include/CMakeLists.txt ===
add_subdirectory(umps)

=== src/support/CMakeLists.txt ===
set(UMPS_LIB_DIR ${CMAKE_INSTALL_LIBDIR}/umps3)

add_subdirectory(bios)
add_subdirectory(crt)
add_subdirectory(ldscripts)
add_subdirectory(libumps)

=== src/tests/CMakeLists.txt ===
add_executable(test_json_serialize test_json_serialize.cc)

add_dependencies(test_json_serialize base)

target_link_libraries(test_json_serialize base)

target_include_directories(test_json_serialize PRIVATE
        ${PROJECT_SOURCE_DIR}/src)

=== src/support/bios/CMakeLists.txt ===
set(ROM_TYPES coreboot exec)

foreach(TYPE ${ROM_TYPES})
        install(FILES ${TYPE}.S
                DESTINATION ${UMPS_DATA_DIR})
endforeach()

set(BIOS_CFLAGS -mips1 -mabi=32 -mno-abicalls -fno-pic -ffreestanding -mfp32)
set(BIOS_CPPFLAGS -I${PROJECT_SOURCE_DIR}/src/include)

foreach(TYPE ${ROM_TYPES})
        add_custom_target(${TYPE}.eb ALL
                COMMAND ${XCGCC} -c -EB ${BIOS_CPPFLAGS} ${BIOS_CFLAGS} -o
                        ${CMAKE_CURRENT_BINARY_DIR}/${TYPE}.eb ${TYPE}.S
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

        add_custom_target(${TYPE}.el ALL
                COMMAND ${XCGCC} -c -EL ${BIOS_CPPFLAGS} ${BIOS_CFLAGS} -o
                        ${CMAKE_CURRENT_BINARY_DIR}/${TYPE}.el ${TYPE}.S
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

        add_custom_target(${TYPE}.eb.rom.umps ALL
                COMMAND umps3-elf2umps -v -b ${TYPE}.eb
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        add_dependencies(${TYPE}.eb.rom.umps ${TYPE}.eb umps3-elf2umps)

        add_custom_target(${TYPE}.el.rom.umps ALL
                COMMAND umps3-elf2umps -v -b ${TYPE}.el
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        add_dependencies(${TYPE}.el.rom.umps ${TYPE}.el umps3-elf2umps)

        set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
                ${TYPE}.eb
                ${TYPE}.el
                ${TYPE}.eb.rom.umps
                ${TYPE}.el.rom.umps)
endforeach()

if(${WORDS_BIGENDIAN})
        set(ENDIAN eb)
else()
        set(ENDIAN el)
endif()

foreach(TYPE ${ROM_TYPES})
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TYPE}.${ENDIAN}.rom.umps
                DESTINATION ${UMPS_DATA_DIR}
                RENAME ${TYPE}.rom.umps)
endforeach()

=== src/frontends/qmps/data/CMakeLists.txt ===
add_subdirectory(icons)

install(FILES umps3.desktop
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

install(FILES org.virtualsquare.umps3.metainfo.xml
        DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

=== src/frontends/qmps/data/icons/CMakeLists.txt ===
set(ICONS_DIR ${CMAKE_INSTALL_DATADIR}/icons/hicolor)

set(ICONS_SIZE 16x16 22x22 24x24 32x32 48x48 64x64)

foreach(SIZE ${ICONS_SIZE})
        install(FILES ${SIZE}/umps3.svg
                DESTINATION ${ICONS_DIR}/${SIZE}/apps)
endforeach()

=== debian/changelog ===
umps3 (3.0.4-1) unstable; urgency=medium

  * d/copyright: Add Metainfo file license
  * New upstream release

 -- Mattia Biondi <mattiabiondi1@gmail.com>  Thu, 22 Oct 2020 10:16:47 +0200

umps3 (3.0.3-1) unstable; urgency=medium

  * d/control: Fix Vcs
  * Add MetaInfo file
  * Update desktop entry file
  * Add screenshots to README.md
  * New upstream release

 -- Mattia Biondi <mattiabiondi1@gmail.com>  Tue, 20 Oct 2020 15:45:39 +0200

umps3 (3.0.1-2) unstable; urgency=medium

  * d/control: Add VirtualSquare Uploader
  * d/control: Fix Vcs

 -- Andrea Capriotti <capriott@debian.org>  Mon, 24 Aug 2020 20:12:42 +0200

umps3 (3.0.1-1) unstable; urgency=medium

  * Initial release

 -- Mattia Biondi <mattiabiondi1@gmail.com>  Mon, 10 Aug 2020 10:40:05 +0200

=== debian/control ===
Source: umps3
Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
Uploaders: Mattia Biondi <mattiabiondi1@gmail.com>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
Section: education
Priority: optional
Build-Depends: debhelper-compat (= 13), cmake (>= 3.5), gcc-mipsel-linux-gnu, libelf-dev, libboost-dev, libsigc++-2.0-dev, qtbase5-dev (>= 5.5)
Standards-Version: 4.5.0
Homepage: https://wiki.virtualsquare.org/#!umps/umps.md
Vcs-Git: https://salsa.debian.org/virtualsquare-team/umps3.git
Vcs-Browser: https://salsa.debian.org/virtualsquare-team/umps3
Rules-Requires-Root: no

Package: umps3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gcc-mipsel-linux-gnu
Description: Virtual machine simulator based around the MIPS R2/3000 microprocessor
 µMPS is an educational computer system architecture and an accompanying
 emulator designed from the ground up to achieve the right trade-off between
 simplicity and elegance on one side, and realism on the other. This makes µMPS
 ideally suited for use in education, such as hands-on operating systems or
 computer architecture university courses.
 .
 The µMPS processor implements the MIPS I instruction set, and can therefore be
 supported out of the box by existing MIPS compilers. The architecture details
 a complete set of I/O devices (terminals, disks, flash devices, printers, and
 network adapters) that feature a clean, consistent, programming interface.
 The previous revision of the µMPS architecture (µMPS2) brings multiprocessor
 support.
 .
 The emulator comes with built-in debugging features and an easy to use
 graphical user interface. Apart from the emulator itself, several support
 utilities are provided that can get you quickly started in developing programs
 for µMPS.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%umps3-$1.tar.gz%" \
	https://github.com/virtualsquare/umps3/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## umps3 3.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # Check for MIPS cross toolchain
 set(XT_PREFIXES ${MIPS_TOOL_PREFIX})
 if(NOT XT_PREFIXES)
-        set(XT_PREFIXES mips-sde-elf-)
+        set(XT_PREFIXES mips-sde-elf- mips64-linux-gnu-)
         if(WORDS_BIGENDIAN)
                 set(XT_PREFIXES mips-linux-gnu- mips-linux-
                         mips-elf- ${XT_PREFIXES})

=== src/base/CMakeLists.txt ===
add_library(base STATIC json.cc trackable_mixin.cc)
target_include_directories(base PRIVATE ${PROJECT_SOURCE_DIR}/src)
target_compile_options(base PRIVATE ${SIGCPP_CFLAGS})

=== src/umps/CMakeLists.txt ===
add_library(umps STATIC
        blockdev.h
        blockdev.cc
        blockdev_params.h
        const.h
        device.h
        device.cc
        disassemble.h
        disassemble.cc
        error.h
        event.h
        event.cc
        machine_config.h
        machine_config.cc
        machine.h
        machine.cc
        memspace.h
        memspace.cc
        mp_controller.h
        mp_controller.cc
        mpic.h
        mpic.cc
        processor.h
        processor.cc
        processor_defs.h
        stoppoint.h
        stoppoint.cc
        symbol_table.h
        symbol_table.cc
        systembus.h
        systembus.cc
        time_stamp.h
        time_stamp.cc
        types.h
        utility.h
        utility.cc
        vde_network.h
        vde_network.cc
        libvdeplug_dyn.h)

add_dependencies(umps base)

target_include_directories(umps PRIVATE
        ${PROJECT_BINARY_DIR}
        ${PROJECT_SOURCE_DIR}/src
        ${PROJECT_SOURCE_DIR}/src/include)

target_compile_options(umps PRIVATE ${SIGCPP_CFLAGS})
target_compile_definitions(umps PRIVATE -DPACKAGE_DATA_DIR="${UMPS_DATA_DIR}")
target_link_libraries(umps PRIVATE base)

add_executable(umps3-elf2umps elf2umps.cc)
target_include_directories(umps3-elf2umps PRIVATE
        ${PROJECT_BINARY_DIR}
        ${PROJECT_SOURCE_DIR}/src
        ${PROJECT_SOURCE_DIR}/src/include)
target_link_libraries(umps3-elf2umps ${LIBELF})

add_executable(umps3-mkdev mkdev.cc)
target_include_directories(umps3-mkdev PRIVATE
        ${PROJECT_BINARY_DIR}
        ${PROJECT_SOURCE_DIR}/src)

add_executable(umps3-objdump disassemble.cc objdump.cc)
target_include_directories(umps3-objdump PRIVATE
        ${PROJECT_BINARY_DIR}
        ${PROJECT_SOURCE_DIR}/src
        ${PROJECT_SOURCE_DIR}/src/include)

install(TARGETS umps3-elf2umps umps3-mkdev umps3-objdump
        RUNTIME
        DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/frontends/qmps/CMakeLists.txt ===
add_subdirectory(data)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

add_executable(umps3
        qmps.qrc
        main.cc
        application.h
        application.cc
        debug_session.h
        debug_session.cc
        monitor_window.h
        monitor_window_priv.h
        monitor_window.cc
        error_hooks.cc
        create_machine_dialog.h
        create_machine_dialog.cc
        stop_mask_view.h
        stop_mask_view.cc
        processor_list_model.h
        processor_list_model.cc
        machine_config_dialog.h
        machine_config_dialog_priv.h
        machine_config_dialog.cc
        machine_config_view.h
        machine_config_view.cc
        trace_browser.h
        trace_browser_priv.h
        trace_browser.cc
        memory_view_delegate.h
        hex_view.h
        hex_view_priv.h
        hex_view.cc
        symbol_table_model.h
        symbol_table_model.cc
        processor_window.h
        processor_window.cc
        code_view.h
        code_view_priv.h
        code_view.cc
        register_set_snapshot.h
        register_set_snapshot.cc
        register_set_widget.h
        register_set_widget.cc
        tlb_model.h
        tlb_model.cc
        terminal_view.h
        terminal_view.cc
        terminal_window.h
        terminal_window_priv.h
        terminal_window.cc
        cpu_status_map.h
        cpu_status_map.cc
        stoppoint_list_model.h
        stoppoint_list_model.cc
        suspect_type_delegate.h
        suspect_type_delegate.cc
        device_tree_view.h
        device_tree_view.cc
        device_tree_model.h
        device_tree_model.cc
        add_breakpoint_dialog.h
        add_breakpoint_dialog.cc
        add_suspect_dialog.h
        add_suspect_dialog.cc
        add_tracepoint_dialog.h
        add_tracepoint_dialog.cc
        address_line_edit.h
        address_line_edit.cc
        mac_id_edit.h
        mac_id_edit.cc
        boolean_item_delegate.h
        boolean_item_delegate.cc
        register_item_delegate.h
        register_item_delegate.cc
        ui_utils.h
        ui_utils.cc
        tree_view.h
        tree_view.cc
        flat_push_button.h
        flat_push_button.cc)

target_include_directories(umps3
        PRIVATE
        ${PROJECT_BINARY_DIR}
        ${PROJECT_SOURCE_DIR}/src
        ${PROJECT_SOURCE_DIR}/src/frontends
        ${PROJECT_SOURCE_DIR}/src/include)

target_link_libraries(umps3 PRIVATE Qt5::Widgets)

set(QT_DEFINES -DQT_NO_DEBUG -DQT_NO_KEYWORDS -DQT_GUI_LIB -DQT_CORE_LIB -DQT_SHARED)
target_compile_options(umps3 PRIVATE ${QT_DEFINES} ${SIGCPP_CFLAGS})

add_dependencies(umps3 base umps)

target_compile_definitions(umps3 PRIVATE -DPACKAGE_VERSION="${PROJECT_VERSION}")

target_link_libraries(umps3
        PRIVATE
        base
        umps
        Qt5::Widgets
        ${SIGCPP_LIBRARIES}
        ${LIBDL})

install(TARGETS umps3
        RUNTIME
        DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/include/umps/CMakeLists.txt ===
install(FILES aout.h arch.h bios_defs.h cp0.h regdef.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/umps3/umps)

=== src/support/crt/CMakeLists.txt ===
set(CRT_FILES crtso crti)

set(CRT_CFLAGS -ffreestanding -ansi -Wall -c -mips1 -mabi=32 -mfp32 -mno-gpopt -G 0 -mno-abicalls -fno-pic)
set(CRT_CPPFLAGS -I${PROJECT_SOURCE_DIR}/src/include)

foreach(FILE ${CRT_FILES})
	add_custom_target(${FILE}.o ALL
		COMMAND ${XCGCC} ${CRT_CPPFLAGS} ${CRT_CFLAGS} -o
			${CMAKE_CURRENT_BINARY_DIR}/${FILE}.o ${FILE}.S
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

	set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
		${FILE}.o)

	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${FILE}.o
		DESTINATION ${UMPS_LIB_DIR})

	install(FILES ${FILE}.S
		DESTINATION ${UMPS_DATA_DIR})
endforeach()

=== src/support/ldscripts/CMakeLists.txt ===
install(FILES umpsaout.ldscript
        DESTINATION ${UMPS_DATA_DIR})

install(FILES umpscore.ldscript
        DESTINATION ${UMPS_DATA_DIR})

=== src/support/libumps/CMakeLists.txt ===
set(UMPS_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR}/umps3/umps)

set(LIBUMPS_CFLAGS -ffreestanding -ansi -Wall -c -mips1 -mabi=32 -mfp32 -mno-gpopt -G 0 -mno-abicalls -fno-pic)
set(LIBUMPS_CPPFLAGS -I${PROJECT_SOURCE_DIR}/src/include)

add_custom_target(libumps.o ALL
	COMMAND ${XCGCC} ${LIBUMPS_CPPFLAGS} ${LIBUMPS_CFLAGS} -o
		${CMAKE_CURRENT_BINARY_DIR}/libumps.o libumps.S
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_custom_target(libumps.e ALL
	COMMAND ${CMAKE_COMMAND} -E copy
		${CMAKE_CURRENT_SOURCE_DIR}/libumps.h
		${CMAKE_CURRENT_BINARY_DIR}
	COMMAND ${CMAKE_COMMAND} -E create_symlink libumps.h libumps.e
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
	libumps.o libumps.h libumps.e)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libumps.o
	DESTINATION ${UMPS_LIB_DIR})

install(FILES libumps.h ${CMAKE_CURRENT_BINARY_DIR}/libumps.e const.h types.h
	DESTINATION ${UMPS_INCLUDE_DIR})

install(FILES libumps.S
	DESTINATION ${UMPS_DATA_DIR})

=== src/frontends/qmps/data/CMakeLists.txt ===
set(ID org.virtualsquare.umps3)

add_subdirectory(icons)

install(FILES ${ID}.desktop
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

install(FILES ${ID}.metainfo.xml
        DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

=== src/frontends/qmps/data/icons/CMakeLists.txt ===
set(ICONS_DIR ${CMAKE_INSTALL_DATADIR}/icons/hicolor)

set(ICONS_SIZE 16x16 22x22 24x24 32x32 48x48 64x64)

foreach(SIZE ${ICONS_SIZE})
        install(FILES ${SIZE}/${ID}.svg
                DESTINATION ${ICONS_DIR}/${SIZE}/apps)
endforeach()

=== debian/changelog ===
umps3 (3.0.5-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:27:45 +1100

umps3 (3.0.5-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:25:11 +0000

umps3 (3.0.5-1build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 01:05:03 +0000

umps3 (3.0.5-1) unstable; urgency=medium

  [ Renzo Davoli ]
  * fix C99 consistency for NULL
  * new man pages (pandoc)

  [ Mattia Rizzolo ]
  * Drop uupdate from d/watch.

 -- Renzo Davoli <renzo@cs.unibo.it>  Tue, 07 Mar 2023 15:30:38 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: umps3
-Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
 Uploaders: Mattia Biondi <mattiabiondi1@gmail.com>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
 Section: education
 Priority: optional

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%umps3-$1.tar.gz%" \
	https://github.com/virtualsquare/umps3/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
